/***************************************************************************
                          addgroup.h  -  description
                             -------------------
    begin                : Wed Apr 14 2004
    copyright            : (C) 2004 by Joern Ossowski
    email                : ossowski@cs.uni-bonn.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ADDGROUP_H
#define ADDGROUP_H

template <class T> class Group;

#include <string>
#include <add/addvarorder.h>


class ADDGroup{
friend class ADD;
friend class ADDVarOrder;
public:
  ADDGroup(void);
  ADDGroup(const std::string&);
  ADDGroup(const ADDGroup&);
  ~ADDGroup(void);
  std::string getName(void) const;
  bool setName(const std::string&);
  std::string getGroupOrder(void);
  bool groupVariable(const std::string&);
  void join(ADDGroup&);
  bool ungroupVariable(const std::string&);
  void ungroup(void);
  bool addVariable(const std::string&);
  bool removeVariable(const std::string&);
  unsigned long size(void) const;
  unsigned long getIndexOfFirstElement(void) const;
  std::string operator[](unsigned long) const;
  ADDGroup& operator<<(const std::string&);
  ADDGroup& operator<<(ADDGroup&);
  ADDGroup& operator>>(const std::string&);
  ADDGroup& operator=(const ADDGroup&);
  bool operator==(const ADDGroup&) const;
  bool operator!=(const ADDGroup&) const;
private:
  static ADD* BDD;
  static ADDVariableOrdering* varOrder;
  Group<ADDUniqueTable>* group;

  ADDGroup(Group<ADDUniqueTable>*);
};

#endif
