/***************************************************************************
                          addoutput.h  -  description
                             -------------------
    begin                : Tue Jul 13 2004
    copyright            : (C) 2004 by Joern Ossowski
    email                : ossowski@cs.uni-bonn.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ADDOUTPUT_H
#define ADDOUTPUT_H

#include <set>
#include <map>
#include <vector>
#include <string>
#include <fstream>

#include <common/constants.h>

#include <add/addfunctioncontainer.h>

class ADDNode;
class ADDFunction;

class ADDOutput{
public:
  static bool storeFunction(const std::string&, const ADDFunction&);
  static bool storeFunctions(const std::string&, const ADDFunctionContainer&);
private:
  ADDOutput(const std::string&);
  ~ADDOutput(void);

  bool storeBDD(const ADDFunctionContainer&);
  void storeBDD(ADDNode*);

  set<ADDNode*> visitedSet;
  ofstream file;
};

#endif
