/***************************************************************************
                          addvarorder.h  -  description
                             -------------------
    begin                : Wed Apr 14 2004
    copyright            : (C) 2004 by Joern Ossowski
    email                : ossowski@cs.uni-bonn.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ADDVARORDER_H
#define ADDVARORDER_H

class ADDGroup;
class ADDNode;
template <class T> class VarOrder;
//definition for uniquetable just change type of data structure and everything changes automatically
#include<common/hashuniquetable.h>
typedef HashUniqueTable<ADDNode> ADDUniqueTable;
typedef VarOrder<ADDUniqueTable> ADDVariableOrdering;

#include <string>

class ADDVarOrder{
friend class ADD;
public:
  static void clear(void);
  static void clearGroups(void);
  static unsigned long size(void);
  static string getVarOrder(void);
	static bool findVariable(const std::string&);
  static bool addVariable(const std::string&);
	static bool prependVariable(const std::string&);
  static bool removeVariable(const std::string&);
  static bool insertVariable(const std::string&, const unsigned long);
  static string getVariable(const unsigned long);
  static unsigned long getVariable(const std::string&);
  static bool isGroupMember(const unsigned long);
  static unsigned long groupCount(void);
  static ADDGroup getGroup(const std::string&);
  static ADDGroup getGroup(const unsigned long);
  static ADDGroup getNextGroup(const ADDGroup&);
  static ADDGroup getPrevGroup(const ADDGroup&);
  static string toString();
private:
  static ADDVariableOrdering* varOrder;
};

#endif
