#ifndef ADD_WRITER_HPP
#define ADD_WRITER_HPP

#include <set>
#include <map>
#include <vector>
#include <string>
#include <fstream>

#include <common/constants.h>

#include <add/addfunctioncontainer.h>

class ADDNode;
class ADDFunction;

class ADDWriter{
public:
  static bool storeFunction(ostream& out, const ADDFunction&);
  static bool storeFunctions(ostream& out, const ADDFunctionContainer&);
private:
  ADDWriter(ostream &out);

  bool storeBDD(const ADDFunctionContainer&);
  unsigned long storeBDD(ADDNode*);

  typedef std::map<ADDNode*,unsigned long> id_map;
  id_map ids;
  
  ostream& out;
};


#endif
