#ifndef HELPER_H
#define HELPER_H

#if __GNUC__ >= 3
  #define LIKELY(X) (__builtin_expect((X),true))
  #define UNLIKELY(X) (__builtin_expect((X),false))
  #define ABS(X) (__builtin_fabs((X)))
#else
  #define LIKELY(X) (X)
  #define UNLIKELY(X) (X)
  #define ABS(X) ((X<0.0?-X:X))
#endif

namespace Common{
  template <class T>
  inline unsigned long hashFunction(T key){
    return ((unsigned long) (key))*12582917;
  }

  template <class T>
  inline unsigned long hashFunction(T key1, T key2){
    return (hashFunction<T>(key1)+((unsigned long)(key2)))*4256249;
  }

  template <class T>
  inline unsigned long hashFunction(T key1, T key2, T key3){
    return (hashFunction<T>(key1,key2)+((unsigned long)(key3)))*741457;
  }

  template <class T>
  inline unsigned long hashFunction(T key1, T key2, T key3, T key4){
    return (hashFunction<T>(key1,key2,key3)+((unsigned long)(key4)))*94573;
  }

  template <class T>
  inline unsigned long hashFunction(T key1, T key2, T key3, T key4, T key5){
    return (hashFunction<T>(key1,key2,key3,key4)+((unsigned long)(key5)));
  }
}

#endif
