/***************************************************************************
                          ptrhashmap.h  -  description
                             -------------------
    begin                : Wed Mar 16 2005
    copyright            : (C) 2005 by Joern Ossowski
    email                : ossowski@cs.uni-bonn.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PTRHASHMAP_H
#define PTRHASHMAP_H

#include <string>

struct PointerTupel2{
  void* key1;
  void* key2;
  void* content;
};

//**********************PtrHashMap2*******************
class PtrHashMap2{
public:
  PtrHashMap2(const unsigned long, const unsigned long, const double);
  ~PtrHashMap2(void);
  void clear(void);
  unsigned long count(void) const;
  bool contains(const void*, const void*) const;
  void* find(const void*, const void*) const;
  void insert(const void*, const void*, const void*);
  void printStat(const std::string&) const;
private:
  unsigned short resizes;
  mutable double maxRatio;
  unsigned short resizeRatio;
  unsigned long counter;
  unsigned long numberOfHashValues;
  unsigned long maxNumberOfHashValues;
  unsigned short shift;
  struct PointerTupel2* hashMap;

  inline unsigned long hashFunction(const void*, const void*) const;
  void resize(void);
};

struct PointerTupel3{
  void* key1;
  void* key2;
  void* key3;
  void* content;
};

//**********************PtrHashMap3*******************
class PtrHashMap3{
public:
  PtrHashMap3(const unsigned long, const unsigned long, const double);
  ~PtrHashMap3(void);
  void clear(void);
  unsigned long count(void) const;
  bool contains(const void*, const void*, const void*) const;
  bool contains(const void*, const void*) const;
  void* find(const void*, const void*, const void*) const;
  void* find(const void*, const void*) const;
  void insert(const void*, const void*, const void*, const void*);
  void insert(const void*, const void*, const void*);
  void printStat(const std::string&) const;
private:
  unsigned short resizes;
  mutable double maxRatio;
  unsigned short resizeRatio;
  unsigned long counter;
  unsigned long numberOfHashValues;
  unsigned long maxNumberOfHashValues;
  unsigned short shift;
  struct PointerTupel3* hashMap;
	
  inline unsigned long hashFunction(const void*, const void*, const void*) const;
  inline unsigned long hashFunction(const void*, const void*) const;
  void resize(void);
};

struct PointerTupel4{
  void* key1;
  void* key2;
  void* key3;
  void* key4;
  void* content;
};

//**********************PtrHashMap4*******************
class PtrHashMap4{
public:
  PtrHashMap4(const unsigned long, const unsigned long, const double);
  ~PtrHashMap4(void);
  void clear(void);
  unsigned long count(void) const;
  bool contains(const void*, const void*, const void*, const void*) const;
  void* find(const void*, const void*, const void*, const void*) const;
  void insert(const void*, const void*, const void*, const void*, const void*);
  void printStat(const std::string&) const;
private:
  unsigned short resizes;
  mutable double maxRatio;
  unsigned short resizeRatio;
  unsigned long counter;
  unsigned long numberOfHashValues;
  unsigned long maxNumberOfHashValues;
  unsigned short shift;
  struct PointerTupel4* hashMap;
	
  inline unsigned long hashFunction(const void*, const void*, const void*, const void*) const;
  void resize(void);
};

struct PointerTupel5{
  void* key1;
  void* key2;
  void* key3;
  void* key4;
  void* key5;
  void* content;
};

//**********************PtrHashMap5*******************
class PtrHashMap5{
public:
  PtrHashMap5(const unsigned long, const unsigned long, const double);
  ~PtrHashMap5(void);
  void clear(void);
  unsigned long count(void) const;
  bool contains(const void*, const void*, const void*, const void*, const void*) const;
  void* find(const void*, const void*, const void*, const void*, const void*) const;
  void insert(const void*, const void*, const void*, const void*, const void*, const void*);
  void printStat(const std::string&) const;
private:
  unsigned short resizes;
  mutable double maxRatio;
  unsigned short resizeRatio;
  unsigned long counter;
  unsigned long numberOfHashValues;
  unsigned long maxNumberOfHashValues;
  unsigned short shift;
  struct PointerTupel5* hashMap;
	
  inline unsigned long hashFunction(const void*, const void*, const void*, const void*, const void*) const;
  void resize(void);
};

#endif
