/***************************************************************************
                          stringhelper.h  -  description
                             -------------------
    begin                : Tue June 01 2004
    copyright            : (C) 2004 by Wolfgang Lenders, Joern Ossowski
    email                : {lenders,ossowski}@cs.uni-bonn.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STRINGHELPER_H
#define STRINGHELPER_H

#include <string>

const std::string DEFAULT_TRIM_CHARS=" \t\r\n";
const std::string DEFAULT_DELIM_CHARS=" \t";

std::string operator+(const std::string&, const unsigned long);

std::string trimLeft(const std::string&, const std::string=DEFAULT_TRIM_CHARS);
std::string trimRight(const std::string&, const std::string=DEFAULT_TRIM_CHARS);
std::string trim(const std::string&, const std::string=DEFAULT_TRIM_CHARS);

std::string peekToken(const std::string&, const std::string=DEFAULT_DELIM_CHARS);
void pushToken(const std::string&, std::string&, const std::string=DEFAULT_DELIM_CHARS);
std::string popToken(std::string&, const std::string=DEFAULT_DELIM_CHARS);
unsigned long countTokens(std::string, const std::string=DEFAULT_DELIM_CHARS);

#endif
