/***************************************************************************
                          ulongarray.h  -  description
                             -------------------
    begin                : Tue Apr 13 2004
    copyright            : (C) 2004 by Wolfgang Lenders, Joern Ossowski
    email                : {lenders,ossowski}@cs.uni-bonn.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ULONGARRAY_H
#define ULONGARRAY_H

#include <string>
#include <common/randomhelper.h>

class ULongArray{
public:
  ULongArray(const unsigned long=0);
  ULongArray(const ULongArray&);
  ~ULongArray(void);
  unsigned long& operator[](const unsigned long);
  bool operator==(const ULongArray&) const;
  ULongArray& operator=(const ULongArray&);
  unsigned long at(const unsigned long index) const;
  std::string print(void) const;
  unsigned long find(const unsigned long query) const;
  unsigned long distance(const ULongArray& secondArray) const;
  void swap(const unsigned long);
  void shift(const unsigned long, const unsigned long);
  void exchange(const unsigned long, const unsigned long);
  ULongArray getIndicesOrderedByValues() const;
  void randomShuffle(const unsigned long);
  unsigned long size() const;
private:
  unsigned long* array;
  unsigned long arraySize;
  static unsigned long ERROR;
  RandomHelper rh;
};

#endif
