/***************************************************************************
                          zaddgroup.h  -  description
                             -------------------
    begin                : Wed Apr 14 2004
    copyright            : (C) 2004 by Joern Ossowski
    email                : ossowski@cs.uni-bonn.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ZADDGROUP_H
#define ZADDGROUP_H

template <class T> class Group;

#include <string>

#include <zadd/zaddvarorder.h>

class ZADDGroup{
friend class ZADD;
friend class ZADDVarOrder;
public:
  ZADDGroup(void);
  ZADDGroup(const std::string&);
  ZADDGroup(const ZADDGroup&);
  ~ZADDGroup(void);
  std::string getName(void) const;
  bool setName(const std::string&);
  std::string getGroupOrder(void);
  bool groupVariable(const std::string&);
  void join(ZADDGroup&);
  bool ungroupVariable(const std::string&);
  void ungroup(void);
  bool addVariable(const std::string&);
  bool removeVariable(const std::string&);
  unsigned long size(void) const;
  unsigned long getIndexOfFirstElement(void) const;
  std::string operator[](unsigned long) const;
  ZADDGroup& operator<<(const std::string&);
  ZADDGroup& operator<<(ZADDGroup&);
  ZADDGroup& operator>>(const std::string&);
  ZADDGroup& operator=(const ZADDGroup&);
  bool operator==(const ZADDGroup&) const;
  bool operator!=(const ZADDGroup&) const;
private:
  static ZADD* BDD;
  static ZADDVariableOrdering* varOrder;
  Group<ZADDUniqueTable>* group;

  ZADDGroup(Group<ZADDUniqueTable>*);
};

#endif
