/***************************************************************************
                          zaddoutput.h  -  description
                             -------------------
    begin                : Tue Jul 13 2004
    copyright            : (C) 2004 by Joern Ossowski
    email                : ossowski@cs.uni-bonn.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ZADDOUTPUT_H
#define ZADDOUTPUT_H

#include <set>
#include <vector>
#include <string>
#include <fstream>


#include <common/constants.h>

#include <zadd/zaddfunctioncontainer.h>

class ZADDNode;
class ZADDFunction;

class ZADDOutput{
public:
  static bool storeFunction(const std::string&, const ZADDFunction&);
  static bool storeFunctions(const std::string&, const ZADDFunctionContainer&);
private:
  ZADDOutput(const std::string&);
  ~ZADDOutput(void);

  bool storeBDD(const ZADDFunctionContainer&);
  void storeBDD(ZADDNode*);

  std::set<ZADDNode*> visitedSet;
  std::ofstream file;
};

#endif
