/***************************************************************************
                          zaddvarorder.h  -  description
                             -------------------
    begin                : Wed Apr 14 2004
    copyright            : (C) 2004 by Joern Ossowski
    email                : ossowski@cs.uni-bonn.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ZADDVARORDER_H
#define ZADDVARORDER_H

class ZADDGroup;
class ZADDNode;
template <class T> class VarOrder;
//definition for uniquetable just change type of data structure and everything changes automatically
#include<common/hashuniquetable.h>
typedef HashUniqueTable<ZADDNode> ZADDUniqueTable;
typedef VarOrder<ZADDUniqueTable> ZADDVariableOrdering;

#include <string>


class ZADDVarOrder{
friend class ZADD;
public:
  static void clear(void);
  static void clearGroups(void);
  static unsigned long size(void);
  static std::string getVarOrder(void);
	static bool findVariable(const std::string&);
  static bool addVariable(const std::string&);
	static bool prependVariable(const std::string&);
  static bool removeVariable(const std::string&);
  static bool insertVariable(const std::string&, const unsigned long);
  static std::string getVariable(const unsigned long);
  static unsigned long getVariable(const std::string&);
  static bool isGroupMember(const unsigned long);
  static unsigned long groupCount(void);
  static ZADDGroup getGroup(const std::string&);
  static ZADDGroup getGroup(const unsigned long);
  static ZADDGroup getNextGroup(const ZADDGroup&);
  static ZADDGroup getPrevGroup(const ZADDGroup&);
private:
  static ZADDVariableOrdering* varOrder;
};

#endif
