/***************************************************************************
                          add.h  -  description
                             -------------------
    begin                : Wed Apr 14 2004
    copyright            : (C) 2004-2008 by Joern Ossowski
    email                : mail@jossowski.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ADD_H
#define ADD_H

#include <add/addvarorder.h>

template <class T> class PtrHashMap2;
template <class T> class PtrHashMap3;
template <class T, class B> class SpecialPtrHashMap;
template <class T> class MemPool;

struct ADD {
  static ADDTerminalNodeUniqueTable drainUniqueTable;
  static MemPool<ADDInnerNode> innerNodeMemPool;
  static MemPool<ADDTerminalNode> terminalNodeMemPool;
  static ADDVariableOrdering variableOrdering;
  static ADDTerminalNode* zeroDrain;
  static ADDTerminalNode* oneDrain;
  static unsigned long deadNodes;
  static unsigned long garbageCollectionDelay;
  static bool dynamicReordering;
  static float dynamicReorderingMaxGrowth;
  static unsigned int dynamicReorderingTimeout;
  static bool dynamicReorderingReverse;
  static unsigned long lastReorderSize;
  static PtrHashMap3<ADDBaseNode> BoolComputedTable;
  static PtrHashMap3<ADDBaseNode> MoveComputedTable;
  static PtrHashMap2<ADDBaseNode> ArithmeticComputedTable;
  static PtrHashMap2<ADDBaseNode> AbstractComputedTable;
  static PtrHashMap2<ADDBaseNode> ExtremaComputedTable;
  static PtrHashMap2<ADDBaseNode> CompareComputedTable;
  static PtrHashMap3<ADDBaseNode> MatrixComputedTable;
  static PtrHashMap3<ADDBaseNode> SpecialComputedTable;

  static void garbageCollect(void);
  static unsigned long size(void);
  static unsigned long countDeadNodes(void);
  static unsigned long setGarbageCollectionDelay(const unsigned long);
  static bool clear(void);
  static void reset();
  static bool swap(unsigned long);

  static void enableDynamicReordering();
  static void disableDynamicReordering();
  static void groupSifting(const float=MAX_GROWTH_DEFAULT, const bool external_garbage_collect=false);

  struct CallBack {
    virtual ~CallBack() {}
    virtual bool operator()() {return false;}
  };
  static void groupExhaustive(CallBack& call_back);

  static void setDynamicReorderingMaxGrowth(float maxGrowth);
  static void setDynamicReorderingTimeout(unsigned int timeout_ms);
  static void setUniqueTableMaxLoadFactor(float load_factor);


  static void reorderingHook(bool forceReordering=false);
};

#endif
