/***************************************************************************
                          addbasenode.h  -  description
                             -------------------
    begin                : Sat Mar 29 2008
    copyright            : (C) 2008 by Joern Ossowski
    email                : mail@jossowski.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ADDBASENODE_H
#define ADDBASENODE_H

#include <common/helper.h>
#include <add/addvarorder.h>
#include <add/add.h>

#include <climits>

class ADDBaseNode{
public:
  ADDBaseNode(void): uniqueTable(0), next(0), preNodeCount(0) {}
  bool isDrain(void) const {return (uniqueTable==0);}
  ADDUniqueTable* getUniqueTable(void) const {return uniqueTable;}
  void setUniqueTable(const ADDUniqueTable* uTable){uniqueTable=const_cast<ADDUniqueTable*>(uTable);}
  void incNodeCount(void){
    if UNLIKELY(preNodeCount==ULONG_MAX){
      if UNLIKELY(uniqueTable==0) ADD::drainUniqueTable.decDeadNodeCount();
      else uniqueTable->decDeadNodeCount();
      --ADD::deadNodes;
      preNodeCount=1;
    } else ++preNodeCount;
  }
  void deleteNode(void){
    if UNLIKELY(--preNodeCount==0){
      if UNLIKELY(isDrain()) ADD::drainUniqueTable.incDeadNodeCount();
      else uniqueTable->incDeadNodeCount();
      ++ADD::deadNodes;
      preNodeCount=ULONG_MAX;
      if UNLIKELY(ADD::deadNodes>=ADD::garbageCollectionDelay) ADD::garbageCollect();
    }
  }
  void garbageCollect(void){
    if UNLIKELY(isDrain()) ADD::drainUniqueTable.incDeadNodeCount();
    else uniqueTable->incDeadNodeCount();
    ++ADD::deadNodes;
    preNodeCount=ULONG_MAX;
  }
  unsigned long getLevel(void) const {return LIKELY(uniqueTable!=0)?uniqueTable->getLevel():ADD::drainUniqueTable.getLevel();}
  unsigned long getRealLevel(void) const {return LIKELY(uniqueTable!=0)?uniqueTable->getRealLevel():ADD::drainUniqueTable.getRealLevel();}

  ADDUniqueTable* uniqueTable;
  ADDBaseNode* next;
  unsigned long preNodeCount;
};

#endif
