/***************************************************************************
                          addterminalnode.h  -  description
                             -------------------
    begin                : Sat Mar 29 2008
    copyright            : (C) 2008 by Joern Ossowski
    email                : mail@jossowski.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ADDTERMINALNODE_H
#define ADDTERMINALNODE_H

#include <add/addbasenode.h>
#include <add/add.h>
#include <common/helper.h>
#include <common/mempool.h>

template <class T> class MemPool;

class ADDTerminalNode : public ADDBaseNode {
public:
  ADDTerminalNode(void) : value(0.0) {}
  static ADDTerminalNode* getNewNode(void){return ADD::terminalNodeMemPool.alloc();}
  static void freeNode(ADDTerminalNode* node){ADD::terminalNodeMemPool.free(node);}
  static unsigned long PEAK(void){return ADD::terminalNodeMemPool.peak();}
  ADDTerminalNode* getNext(void) const {return static_cast<ADDTerminalNode*>(next);}
  void setNext(const ADDTerminalNode* next){this->next=static_cast<ADDBaseNode*>(const_cast<ADDTerminalNode*>(next));}
  void setValue(double value){
    preNodeCount=0;
    this->value=value;
  }
  double getValue(void) const {return value;}
private:
  double value;
};

#endif
