/***************************************************************************
                           randomhelper.cpp  -  description
                             -------------------
    begin                : Sun Jun 6 2004
    copyright            : (C) 2004 by Wolfgang Lenders, Joern Ossowski
    email                : {lenders,ossowski}@cs.uni-bonn.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "randomhelper.h"
#include <cmath>
#include <cstdlib>
#include <ctime>

bool RandomHelper::initialized=false;

RandomHelper randomHelper;

RandomHelper::RandomHelper(void){
  if(!initialized) init();
}

RandomHelper::~RandomHelper(void){
}

unsigned long RandomHelper::getULong(const unsigned long limit){
  return (limit==0)?0:(rand()%limit);
}

void RandomHelper::getULongs(unsigned long& firstChoice, unsigned long& secondChoice, const unsigned long limit){
  if(limit<2) return;
  firstChoice=rand()%limit;
  do {
    secondChoice=rand()%limit;
  } while (firstChoice==secondChoice);
}

double RandomHelper::getDouble(const double limit){
  return getBool()?getUDouble(limit):-getUDouble(limit);
}

double RandomHelper::getUDouble(const double limit){
  return limit*((double)getULong(100000))/100000.0;
}

bool RandomHelper::getBool(void){
  return getULong(2);
}

void RandomHelper::init(void){
  if(!initialized){
    srand(static_cast<unsigned>(time(0)));
    initialized=true;
  }
}
