/***************************************************************************
                          stringhelper.cpp  -  description
                             -------------------
    begin                : Tue June 01 2004
    copyright            : (C) 2004 by Wolfgang Lenders, Joern Ossowski
    email                : {lenders,ossowski}@cs.uni-bonn.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <common/stringhelper.h>
#include <sstream>

using namespace std;

string operator+(const string& str, const unsigned long number){
  ostringstream temp;
  temp << number;

  return str+temp.str();
}

string trimLeft(const string& str, const string trimChars){
  string result=str;

  string::size_type index=result.find_first_not_of(trimChars);
  if(index>0) result.erase(0,index);

  return result;
}

string trimRight(const string& str, const string trimChars){
  string result=str;

  string::size_type index=result.find_last_not_of(trimChars);
  result.erase(index+1,result.length()-index-1);

  return result;
}

string trim(const string& str, const string trimChars){
  return trimLeft(trimRight(str,trimChars),trimChars);
}

string peekToken(const string& str, const string delimChars){
  return str.substr(0,str.find_first_of(delimChars));
}

void pushToken(const string& token, string& str, const string delimChars){
  if(delimChars.length()) str=token+delimChars[0]+str;
}

string popToken(string& str, const string delimChars){
  string ret=str.substr(0,str.find_first_of(delimChars));
  str.erase(0,ret.length());
  str=trimLeft(str,delimChars);

  return ret;
}

unsigned long countTokens(string str, const string delimChars){
  unsigned long tokenCounter=0;

  while(!str.empty()){
    popToken(str,delimChars);
    ++tokenCounter;
  }

  return tokenCounter;
}
