/***************************************************************************
                          zadd.h  -  description
                             -------------------
    begin                : Wed Apr 14 2004
    copyright            : (C) 2004-2008 by Joern Ossowski
    email                : mail@jossowski.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ZADD_H
#define ZADD_H

#include <zadd/zaddvarorder.h>

template <class T> class PtrHashMap3;
template <class T> class PtrHashMap4;
template <class T> class PtrHashMap5;
template <class T, class B> class SpecialPtrHashMap;
template <class T> class MemPool;

struct ZADD {
  static ZADDTerminalNodeUniqueTable drainUniqueTable;
  static MemPool<ZADDInnerNode> innerNodeMemPool;
  static MemPool<ZADDTerminalNode> terminalNodeMemPool;
  static ZADDVariableOrdering variableOrdering;
  static ZADDTerminalNode* zeroDrain;
  static ZADDTerminalNode* oneDrain;
  static unsigned long deadNodes;
  static unsigned long garbageCollectionDelay;
  static bool dynamicReordering;
  static float dynamicReorderingMaxGrowth;
  static unsigned long lastReorderSize;
  static PtrHashMap4<ZADDBaseNode> BoolComputedTable;
  static PtrHashMap3<ZADDBaseNode> MoveComputedTable;
  static PtrHashMap4<ZADDBaseNode> ArithmeticComputedTable;
  static PtrHashMap3<ZADDBaseNode> AbstractComputedTable;
  static PtrHashMap4<ZADDBaseNode> ExtremaComputedTable;
  static PtrHashMap4<ZADDBaseNode> CompareComputedTable;
  static PtrHashMap5<ZADDBaseNode> MatrixComputedTable;

  static void garbageCollect(void);
  static unsigned long size(void);
  static unsigned long countDeadNodes(void);
  static unsigned long setGarbageCollectionDelay(const unsigned long);
  static bool clear(void);
  static bool swap(unsigned long);

  static void enableDynamicReordering();
  static void disableDynamicReordering();
  static void groupSifting(const float=MAX_GROWTH_DEFAULT, const bool external_garbage_collect=false);
  static void setDynamicReorderingMaxGrowth(float maxGrowth);
  static void setUniqueTableMaxLoadFactor(float);
  
  static void dynamicReorderHook();  
};

#endif
