/***************************************************************************
                          zaddterminalnode.h  -  description
                             -------------------
    begin                : Sat Mar 29 2008
    copyright            : (C) 2008 by Joern Ossowski
    email                : mail@jossowski.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ZADDTERMINALNODE_H
#define ZADDTERMINALNODE_H

#include <zadd/zaddbasenode.h>
#include <zadd/zadd.h>
#include <common/helper.h>
#include <common/mempool.h>

template <class T> class MemPool;

class ZADDTerminalNode : public ZADDBaseNode {
public:
  ZADDTerminalNode(void) : value(0.0) {}
  static ZADDTerminalNode* getNewNode(void){return ZADD::terminalNodeMemPool.alloc();}
  static void freeNode(ZADDTerminalNode* node){ZADD::terminalNodeMemPool.free(node);}
  static unsigned long PEAK(void){return ZADD::terminalNodeMemPool.peak();}
  ZADDTerminalNode* getNext(void) const {return static_cast<ZADDTerminalNode*>(next);}
  void setNext(const ZADDTerminalNode* next){this->next=static_cast<ZADDBaseNode*>(const_cast<ZADDTerminalNode*>(next));}
  void setValue(double value){
    preNodeCount=0;
    this->value=value;
  }
  double getValue(void) const {return value;}
private:
  double value;
};

#endif
