/***************************************************************************
                          zaddvarorder.cpp  -  description
                             -------------------
    begin                : Wed Apr 14 2004
    copyright            : (C) 2004-2008 by Joern Ossowski
    email                : mail@jossowski.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <zadd/zadd.h>
#include <zadd/zaddvarorder.h>
#include <common/constants.h>

#include <climits>

void ZADDVarOrder::clear(void){
  ZADD::garbageCollect();
  ZADD::variableOrdering.clear();
}

unsigned long ZADDVarOrder::size(void){
  return ZADD::variableOrdering.size();
}

std::string ZADDVarOrder::getVarOrder(void){
  return ZADD::variableOrdering.getVariableOrdering();
}

std::string ZADDVarOrder::getVariableName(const unsigned long index){
  return ZADD::variableOrdering.getVariable(index)->getName();
}

bool ZADDVarOrder::insertVariable(const unsigned long index){
  return ZADD::variableOrdering.insertVariable(index);
}

bool ZADDVarOrder::insertVariables(const unsigned long index, const unsigned long count){
  return ZADD::variableOrdering.insertVariables(index,count);
}

bool ZADDVarOrder::insertVariable(const std::string& label, const unsigned long index){
  return ZADD::variableOrdering.insertVariable(label,index);
}

bool ZADDVarOrder::addVariable(){
  return ZADD::variableOrdering.appendVariable();
}

bool ZADDVarOrder::addVariable(const std::string& label){
  return ZADD::variableOrdering.appendVariable(label);
}

bool ZADDVarOrder::prependVariable(){
  return ZADD::variableOrdering.prependVariable();
}

bool ZADDVarOrder::prependVariable(const std::string& label){
  return ZADD::variableOrdering.prependVariable(label);
}

bool ZADDVarOrder::removeVariable(const unsigned long index){
  ZADD::garbageCollect();  
  return ZADD::variableOrdering.removeVariable(index);
}

bool ZADDVarOrder::removeVariable(const std::string& label){
  return ZADDVarOrder::removeVariable(ZADDVarOrder::getVariable(label));
}

unsigned long ZADDVarOrder::getVariable(const std::string& variable){
  return ZADD::variableOrdering[variable];
}

bool ZADDVarOrder::isGroupMember(const unsigned long index){
  return (index>=size())?false:ZADD::variableOrdering.getVariable(index)->getGroup();
}

unsigned long ZADDVarOrder::groupCount(void){
  return ZADD::variableOrdering.groupCount();
}
