/***************************************************************************
                          zaddvarorder.h  -  description
                             -------------------
    begin                : Wed Apr 14 2004
    copyright            : (C) 2004-2008 by Joern Ossowski
    email                : mail@jossowski.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ZADDVARORDER_H
#define ZADDVARORDER_H

class ZADDBaseNode;
class ZADDInnerNode;
class ZADDTerminalNode;
//definition for uniquetable just change type of data structure and everything changes automatically
#include <common/varorder.h>
#include <common/hashuniquetable.h>
#include <common/hashdrainuniquetable.h>
typedef HashUniqueTable<ZADDInnerNode,ZADDBaseNode> ZADDUniqueTable;
typedef HashDrainUniqueTable<ZADDTerminalNode> ZADDTerminalNodeUniqueTable;
typedef VarOrder<ZADDUniqueTable> ZADDVariableOrdering;
typedef Group<ZADDUniqueTable> ZADDGroup;
typedef Variable<ZADDUniqueTable> ZADDVariable;

#include <string>

struct ZADDVarOrder{
  static void clear(void);
  static unsigned long size(void);
  static std::string getVarOrder(void);
  static bool addVariable();
  static bool addVariable(const std::string& name);
  static bool prependVariable();
  static bool prependVariable(const std::string& name);
  static bool removeVariable(const unsigned long index);
  static bool removeVariable(const std::string& name);
  static bool insertVariable(const unsigned long index);
  static bool insertVariables(const unsigned long index, const unsigned long count);
  static bool insertVariable(const std::string&, const unsigned long index);
  static std::string getVariableName(const unsigned long index);
  static unsigned long getVariable(const std::string&);
  static bool isGroupMember(const unsigned long index);
  static unsigned long groupCount(void);
};

#endif
