/***************************************************************************
 *   Copyright (C) 2010 by Joachim Klein                                   *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "CSVFile.hpp"
#include <iostream>
#include <fstream>

using namespace vereofy;

CSVFile::CSVFile(const std::string& filename_) : first(true), filename(filename_) {
}

CSVFile::~CSVFile() {
  write();
}

void CSVFile::addColumn(const std::string& header, const std::string& value) {
  header_stream << (first?"":";") << header;
  value_stream << (first?"":";") << value;

  first=false;
}

void CSVFile::write() {
  if (first) return;

  std::ofstream out(filename.c_str());
  out << header_stream.str() << "\n";
  out << value_stream.str() << "\n";
  out.close();
}
