/***************************************************************************
 *   Copyright (C) 2010 by Joachim Klein                                   *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef CSVFILE_HPP
#define CSVFILE_HPP

#include <string>
#include <sstream>
#include <boost/shared_ptr.hpp>
#include <boost/lexical_cast.hpp>


namespace vereofy {

  // Writes data in destructor
  class CSVFile {
  public:
    typedef boost::shared_ptr<CSVFile> ptr;

    CSVFile(const std::string& filename);
    ~CSVFile();

    template <class T>
    void addColumn(const std::string& header, const T& value) {
      addColumn(header, boost::lexical_cast<std::string>(value));
    }

    void addColumn(const std::string& header, const std::string& value);
    
    // write current information to file. May be called multiple times
    void write();

  private:
    bool first;
    std::string filename;
    std::stringstream header_stream;
    std::stringstream value_stream;
  };

}

#endif

