/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef BDD_HELPERS_HPP
#define BDD_HELPERS_HPP

#include <boost/smart_ptr.hpp>

#include "vereofy/setup.hpp"
#include "vereofy/common/tracing.hpp"
#include "vereofy/common/checks.hpp"
#include "vereofy/common/errors.hpp"

#include "vereofy/system/symb_automaton/varmanager.hpp"

#include "bdd_checks.hpp"
#include <exception>
#include <sstream>
#include <iostream>



#define TRACE_BDD_FUNCTION(scope, function, comment)                    \
  TRACE(scope,                                                          \
        #function,                                                      \
        std::cout << "Trace: " << scope << "::" << #function << " " << comment << std::endl; \
        ((const BDDFunction&)function).printEssentialVariables();              \
        ((const BDDFunction&)function).printPaths();                           \
        )

#define TRACE_BDD_FUNCTION_CONTAINER(scope, function_container, comment) \
  TRACE(scope,                                                          \
        #function_container,                                                    \
        std::cout << "Trace: " << scope << "::" << #function_container << " " << comment << std::endl; \
        containerPrint(function_container); \
        )



#include "bdd_container_helpers.hpp"
#include "bdd_var_helpers.hpp"
#include "bdd_set_helpers.hpp"
#include "bdd_cubeset_helpers.hpp"
#include "bdd_assignment_helpers.hpp"
#include "bdd_stats.hpp"

#endif
