/***************************************************************************
 *   Copyright (C) 2009 by Joachim Klein                                   *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/



#ifndef BDD_OP_TRACE_HPP
#define BDD_OP_TRACE_HPP


#include <string>
#include "vereofy/common/bdd_helpers.hpp"

#define BDD_OP_TRACE1(name, result, input1)       \
  TRACE("bdd_op_trace", name,                     \
    do {                                          \
      std::vector<BDDFunction> arguments;         \
      arguments.push_back(input1);                \
                                                  \
      BDD_OpTraceHelper::trace(name,              \
                               Tracing::getTraceCount(TRACE_GET_FULL_NAME("bdd_op_trace", name)), \
                               result,                                  \
                               arguments);                              \
    } while (false))


#define BDD_OP_TRACE2(name, result, input1,input2)      \
  TRACE("bdd_op_trace", name,                     \
    do {                                          \
      std::vector<BDDFunction> arguments;         \
      arguments.push_back(input1);                \
      arguments.push_back(input2);                \
                                                  \
      BDD_OpTraceHelper::trace(name,              \
                               Tracing::getTraceCount(TRACE_GET_FULL_NAME("bdd_op_trace", name)), \
                               result,                                  \
                               arguments);                              \
    } while (false))      



namespace vereofy {

  class BDD_OpTraceHelper {
  public:
    static void trace(const std::string &name, 
                      unsigned int counter,
                      const BDDFunction& result,
                      const std::vector<BDDFunction>& arguments);
  };
}

#endif
