/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef BDD_SET_HELPERS_HPP
#define BDD_SET_HELPERS_HPP

// don't include individually, include bdd_helpers.hpp instead

namespace vereofy {

  inline bool bdd_sets_have_intersection(const BDDFunction& set_1,
                                         const BDDFunction& set_2) {
    // TODO: checks
    bool rv=(set_1 & set_2)!=BDDFunction::ZERO();
    return rv;
  }


  inline bool bdd_set_is_contained(const BDDFunction& set_1,
                                   const BDDFunction& set_2) {
    // TODO: checks
    bool rv=(set_1 & !set_2) == BDDFunction::ZERO();
    return rv;
  }

  inline bool bdd_is_element_of_set(const BDDFunction& element,
                                    const BDDFunction& set) {
    // TODO: checks
    bool rv=bdd_sets_have_intersection(element, set);
    
    return rv;
  }

}

#endif
