/***************************************************************************
 *   Copyright (C) 2011 by Joachim Klein                                   *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef BDD_STATS_HPP
#define BDD_STATS_HPP

// don't include individually, include bdd_helpers.hpp instead

namespace vereofy {
  
  /**
   * Returns the number of BDD nodes that are currently allocated 
   * (active + dead, but not yet garbage collected)
   */
  inline unsigned long bdd_nodes_allocated() {
    return BDD::size();
  }

  /**
   * Returns the number of BDD nodes that are currently dead
   * (but not yet garbage collected)
   */
  inline unsigned long bdd_nodes_dead() {
    return BDD::countDeadNodes();
  }

  /**
   * Returns the number of BDD nodes that are currently active
   */
  inline unsigned long bdd_nodes_active() {
    CHECK(1, bdd_nodes_allocated() >= bdd_nodes_dead(), "");
    return bdd_nodes_allocated() - bdd_nodes_dead();
  }



}


#endif
