/***************************************************************************
 *   Copyright (C) 2009 by Joachim Klein                                   *
 *   klein@tcs.inf.tu-dresden.de                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "countdown_clock.hpp"

CountdownClock::CountdownClock(unsigned int milliseconds_) : 
  milliseconds(milliseconds_) {
  restart();
}

void CountdownClock::restart() {
  if (milliseconds==0) return;
  start_time=clock();
}

bool CountdownClock::isFinished() {
  if (milliseconds==0) return false;

  clock_t current_time=clock();

  if (current_time < start_time) {
    return true;   // there was wrap around, assume we are finished
    // TODO: better handling
  }

  return (current_time-start_time) >= milliseconds*(CLOCKS_PER_SEC/1000);
}
