/***************************************************************************
 *   Copyright (C) 2009 by Joachim Klein                                   *
 *   klein@tcs.inf.tu-dresden.de                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef COUNTDOWN_CLOCK_HPP
#define COUNTDOWN_CLOCK_HPP

#include <ctime>

/**
 * A resetable countdown clock. If milliseconds=0, will never finish
 */
class CountdownClock {
public:
  CountdownClock(unsigned int milliseconds=0);

  void restart();
  bool isFinished();

private:
  unsigned long milliseconds;
  clock_t start_time;
};

#endif
