/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef ERRORS_HPP
#define ERRORS_HPP

#include <string>
#include <boost/lexical_cast.hpp>

#define THROW_UNIMPLEMENTED() do {throw std::string("Unimplemented functionality at Vereofy source location ") + __FILE__ + ", line: "+ boost::lexical_cast<std::string>(__LINE__);} while (0)
#define CHECK_SUCCESS(x) do {if (x) {} else throw std::string("Internal check failed at Vereofy source location ")+std::string(__FILE__) + ", line "+ boost::lexical_cast<std::string>(__LINE__)+": "+#x+" not successful!";} while (0)

#endif
