/***************************************************************************
 *   Copyright (C) 2008-2009 by Tobias Blechmann                           *
 *   blechman@tcs.inf.tu-dresden.de                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <sstream>

#include <boost/foreach.hpp>
#define foreach BOOST_FOREACH
#include <boost/lexical_cast.hpp>

#include "functions.hpp"

using namespace std;

string vereofy::setOfStrToStr(const set<string>& setOfStrings) {
  string result;
  foreach (string cur, setOfStrings) result += cur + ", ";
  return result.substr(0, result.length() -2);
}

list<string> vereofy::stringToList(string s) {
  list<string> result;
  string::size_type pos;
  while ((pos = s.find(",")) != string::npos) {
    result.push_back(s.substr(0, pos));
    s.erase(0, pos+1);
  }
  if (s != "") result.push_back(s);
  return result;
}

vector<string> vereofy::stringToVector(string s) {
  vector<string> result;
  string::size_type pos;
  while ((pos = s.find(",")) != string::npos) {
    result.push_back(s.substr(0, pos));
    s.erase(0, pos+1);
  }
  if (s != "") result.push_back(s);
  return result;
}


std::pair<std::string, std::string> vereofy::splitAt(const std::string& text, char splitting_symbol) {
  std::size_t pos=text.find_first_of(splitting_symbol);
  if (pos==std::string::npos) {
    return make_pair(text, "");
  }
  if (pos==0) {
    make_pair("", text.substr(pos+1));
  }

  return make_pair(text.substr(0, pos), text.substr(pos+1));

}
