/***************************************************************************
 *   Copyright (C) 2008-2009 by Tobias Blechmann                           *
 *   blechman@tcs.inf.tu-dresden.de                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/**
@author Tobias Blechmann
*/

#ifndef STOPWATCH_H
#define STOPWATCH_H

#include <string>
#include <ctime>
#if !defined(_WIN32)
 #include <sys/resource.h>
 #include <unistd.h>
#endif
#include <string>


namespace vereofy {
  class StopWatch {
  public:
    StopWatch();
    ~StopWatch();
    void start();
    void stop();
    void print(const std::string&);
    std::string getCPUTime() const;
    
    double getElapsedTime() const;
    std::string getElapsedTimeString() const;

    std::string toString() const;
  private:
#if !defined(_WIN32)
    struct rusage usage;
#endif
    clock_t startClock;
    time_t startTime;
    double elapsedTime;
    long startCPUTimeSec, startCPUTimeUSec, CPUTimeSec, CPUTimeUSec;
  };
}

#endif
