#ifndef AP_TRANSFORMATION_HPP
#define AP_TRANSFORMATION_HPP

#include "APSet.hpp"
#include "vereofy/common/BitSet.hpp"

namespace vereofy {

class APTransformation {
public:
  APTransformation(ltl2dstar::APSet_cp from,
                   ltl2dstar::APSet_cp to) {
    mapping.resize(to->size());
    for (unsigned int i = 0;
         i < to->size();
         i++) {
      int source = from->find(to->getAP(i));
      if (source == -1) {
        unused.set(i);
      } else {
        mapping.at(i) = (unsigned int) source;
      }
    }
  }

  bool hasSource(unsigned int index) {
    return !unused.get(index);
  }

  unsigned int getSourceFor(unsigned int index) {
    CHECK_SUCCESS(hasSource(index));
    return mapping.at(index);
  }

private:
  BitSet unused;
  std::vector<unsigned int> mapping;
};

}

#endif
