#ifndef BDD_RABIN_ACCEPTANCE_HPP
#define BDD_RABIN_ACCEPTANCE_HPP

#include "BDD_RabinPair.hpp"

// disjunction of BDD_RabinPairs
struct BDD_RabinAcceptance {

  typedef boost::shared_ptr<BDD_RabinAcceptance> ptr;
  
  unsigned int countPairs() const {
    return pairs.size();
  }
  
  BDD_RabinPair& getPair(unsigned int index)  {
    return pairs.at(index);
  }

  const BDD_RabinPair& getPair(unsigned int index) const {
    return pairs.at(index);
  }

  void addPair(const BDD_RabinPair& pair) {
    pairs.push_back(pair);
  }
  
  std::vector<BDD_RabinPair> pairs;
};

#endif
