#ifndef CHECK_LANGUAGE_HPP
#define CHECK_LANGAUGE_HPP

#include "VarManagerG4G.hpp"
#include "vereofy/modelcheck/specifications/ltl/LTLFormula.hpp"
#include "BDD_G4G_NRA.hpp"
#include "Automaton.hpp"
#include "DRA_BDD.hpp"

class CheckLanguage {
public:
  CheckLanguage(VarManagerG4G& varmanager_,
                vereofy::ltl_check::LTLFormula_ptr ltl_,
                bool print_stats_=false,
                bool tight_game_=false,
                bool check_strategy_=false) :
    varmanager(varmanager_),
    ltl(ltl_),
    print_stats(print_stats_),
    tight_game(tight_game_),
    check_strategy(check_strategy_) {

    // convert (neg.) formula to DRA
    init_dra();
  }

  
  bool is_equivalent(vereofy::ltl_check::BDD_G4G_NRA& bdd_g4g);
  
private:
  VarManagerG4G& varmanager;
  vereofy::ltl_check::LTLFormula_ptr ltl;
  bool print_stats;
  bool tight_game;
  bool check_strategy;
  DRA_BDD::ptr dra_bdd;

  void init_dra();
};

#endif
