#ifndef REACHABILITY_HPP
#define REACHABILITY_HPP

#include "vereofy/common/bdd_helpers.hpp"
#include "vereofy/common/stopwatch.hpp"

class Reachability {
public:
  static BDDFunction reachable(BDDFunction initial,
                        BDDFunction delta,
                        BDDFunction csStateVars,
                        BDDFunction csTransitionVars = BDDFunction::ONE()) {
    vereofy::StopWatch stopwatch;
    stopwatch.start();
    BDDFunction deltaXY = delta.exists(csTransitionVars);
    TRACE_BDD_FUNCTION("reachable", deltaXY, "");
    BDDFunction oldReachable=BDDFunction::ZERO();
    BDDFunction reachable=initial;
    int steps = 0;
    while (reachable!=oldReachable) {
      TRACE_BDD_FUNCTION("reachable", reachable, "step " << steps);
      oldReachable=reachable;
      ++steps;
      reachable |= ((deltaXY & reachable).exists(csStateVars)).moveUp();
    }
    stopwatch.stop();
    
    
    TRACE_BDD_FUNCTION("reachable", reachable, "finished");
    return reachable;
  }
};

#endif
