#ifndef SCC_COUNTER_HPP
#define SCC_COUNTER_HPP

#include "SCCFinder.hpp"

class SCCCounter {
public:
  SCCCounter() {counter = 0;}
     
  bool operator()(BDDFunction& C) {
    TRACE_BDD_FUNCTION("SCC", C, counter);
     counter++;

     return true;
  }

  unsigned long getCount() const {return counter;}

  static unsigned long count_sccs(BDDFunction states, 
                                  BDDFunction E, 
                                  BDDFunction csStateVars) {
    SCCCounter counter;
    
    SCCFinder scc_finder(E, csStateVars);
    scc_finder.Lockstep(states, counter);

    return counter.getCount();
  }
  
private:
  unsigned long counter;
};



#endif
