#include "VarManagerG4G.hpp"
#include "StateVars_DA.hpp"
#include "vereofy/common/bdd_helpers.hpp"
#include "vereofy/system/symb_automaton/symb_flat_datadomain.hpp"

StateVars_DA::~StateVars_DA() {
  CHECK_SUCCESS(free());
}

bool StateVars_DA::free() {
  bool rv = true;
  for (unsigned int i=0;i<size();i++) {
    rv &= varmanager.free((*this)[i]);
  }
  return rv;
}


BDDFunction StateVars_DA::da_state_2_bdd(std::size_t state_index, bool prime) const {
  CHECK_SUCCESS(state_index <= da_state_count);
  
  BDDFunction result = 
    pairwiseEQUIV(*this, 
                  da_state_encoding->getEncoding(state_index));
  
  if (prime) {
    return result.moveDown();
  } else {
    return result;
  }
}

