#ifndef STATE_VARS_DA_HPP
#define STATE_VARS_DA_HPP

// fwd
class VarManagerG4G;

struct StateVars_DA : public BDDFunctionContainer {
  friend class VarManagerG4G;
  typedef boost::shared_ptr<StateVars_DA> ptr;

  StateVars_DA(VarManagerG4G& varmanager_) : 
    da_state_count(0),
    varmanager(varmanager_) {}

  ~StateVars_DA();

  unsigned int getDAStateCount() const {
    return da_state_count;
  }

  BDDFunction da_state_2_bdd(std::size_t state_index, bool prime) const;

private:
  boost::shared_ptr<Symb_FlatDataDomain> da_state_encoding;
  unsigned int da_state_count;
  VarManagerG4G& varmanager;

  bool free();
};


#endif
