#include "VarManagerG4G.hpp"
#include "StateVars_G4G.hpp"


StateVars_G4G::~StateVars_G4G() {
  CHECK_SUCCESS(free());
}

void StateVars_G4G::free_above(unsigned int max_set) {
  bool rv = true;
  
  while (A.size() > max_set) {
    for (unsigned int j=0;j<A[max_set].size();j++) {
      rv &= varmanager.free((A[max_set])[j]);
    }
    A.erase(A.begin() + max_set);

    for (unsigned int j=0;j<B[max_set].size();j++) {
      rv &= varmanager.free((B[max_set])[j]);
    }
    B.erase(B.begin() + max_set);
  }

  CHECK_SUCCESS(rv);
}

bool StateVars_G4G::free() {
  bool rv = true;
  for (unsigned int i=0;i<A.size();i++) {
    for (unsigned int j=0;j<A[i].size();j++) {
      rv &= varmanager.free((A[i])[j]);
    }
  }
  for (unsigned int i=0;i<B.size();i++) {
    for (unsigned int j=0;j<B[i].size();j++) {
      rv &= varmanager.free((B[i])[j]);
    }
  }
  return rv;
}
