#ifndef STATE_VARS_G4G_HPP
#define STATE_VARS_G4G_HPP

#include "boost/shared_ptr.hpp"

// fwd
class VarManagerG4G;

struct StateVars_G4G {
  friend class VarManagerG4G;
  typedef boost::shared_ptr<StateVars_G4G> ptr;

  StateVars_G4G(VarManagerG4G& varmanager_) :
    varmanager(varmanager_) {}

  ~StateVars_G4G();

  const BDDFunctionContainer& getA(unsigned int j) const {
    return A.at(j);
  }
  
  const BDDFunctionContainer& getB(unsigned int j) const {
    return B.at(j);
  }
  
  unsigned int getSubsetCount() const {
    CHECK_SUCCESS(A.size() == B.size());
    return A.size();
  }
  
  void free_above(unsigned int index);
 
private:
  std::vector<BDDFunctionContainer> A;
  std::vector<BDDFunctionContainer> B;
  VarManagerG4G& varmanager;

  bool free();
};


#endif
