#ifndef STATE_VARS_NBA_HPP
#define STATE_VARS_NBA_HPP

// fwd
class VarManagerG4G;

struct StateVars_NBA : public BDDFunctionContainer {
  typedef boost::shared_ptr<StateVars_NBA> ptr;
  friend class VarManagerG4G;

  StateVars_NBA(VarManagerG4G& varmanager_) : 
    varmanager(varmanager_) {
    static unsigned int nba_counter = 0;
    
    nba_index = nba_counter++;
  }

  ~StateVars_NBA();

  unsigned int nba_index;

private:
  VarManagerG4G& varmanager;

  // don't allow copying of StateVars_NBA
  explicit StateVars_NBA(const StateVars_NBA& other);

  bool free();
};


#endif
