/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/



#include "ModelCheckerInit.hpp"

#include "vereofy/modelcheck/specifications/Specification.hpp"

using namespace std;
using namespace vereofy;

#ifdef HAVE_CHECKERS

// ASL
#include "vereofy/modelcheck/checkers/branching_time_check/ASL_ModelChecker.hpp"
#define HAVE_ASL_CHECKER

// LTL
#include "vereofy/modelcheck/checkers/ltl_check/LTLModelChecker.hpp"
#define HAVE_LTL_CHECKER

void vereofy::init_modelcheckers() {
#ifdef HAVE_ASL_CHECKER
  ModelChecker::registerChecker(ASL_SPEC, ModelChecker::ptr(new ASL_ModelChecker));
#endif 

#ifdef HAVE_LTL_CHECKER
  ModelChecker::registerChecker(LTL_SPEC, ModelChecker::ptr(new LTLModelChecker));
#endif 
}

#endif
