/***************************************************************************
 *   Copyright (C) 2009 by Joachim Klein                                   *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef MODELCHECKING_RESULT_TRACE_FOR_JAVA_HPP
#define MODELCHECKING_RESULT_TRACE_FOR_JAVA_HPP

#include <string>
#include <boost/shared_ptr.hpp>
#include "vereofy/system/symb_automaton/symb_trace_for_java.hpp"

// fwd 
class VereofyContext;
namespace vereofy {
  class ModelCheckingResultTrace;
}

class ModelCheckingResultTrace_for_java {
public:
  bool hasParent() const;
  unsigned int getParent() const;
  std::string getText() const;
  SymbTrace_for_java getTracePrefix();
  SymbTrace_for_java getTraceCycle();
  std::string getTraceType() const;

  std::string toString() const;

  boost::weak_ptr<VereofyContext> context;
  boost::weak_ptr<vereofy::ModelCheckingResultTrace> result_trace;
};



#endif
