/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "ModelCheckingResult_for_java.hpp"
#include "ModelCheckingResult.hpp"

#include "ModelCheckingResultTrace_for_java.hpp"

#include "vereofy/system/symb_automaton/symb_component_instance.hpp"
#include "vereofy/common/weak_ptr_helper.hpp"

using namespace vereofy;

unsigned int ModelCheckingResult_for_java::countTraces() const {
  return access_weak_ptr(result)->countTraces();
}

ModelCheckingResultTrace_for_java ModelCheckingResult_for_java::getTrace(unsigned int index) {
  ModelCheckingResultTrace::ptr result_trace=access_weak_ptr(result)->getTrace(index);

  ModelCheckingResultTrace_for_java result_trace_java;
  result_trace_java.result_trace=result_trace;
  result_trace_java.context=context;

  return result_trace_java;
}

std::string ModelCheckingResult_for_java::getResultAsXML() const {
  std::stringstream ss;
  xml_header(ss);
  xml_tag_open(ss, "vereofy_trace");
  ss << "\n";

  // print interface
  access_weak_ptr(result)->getSystem()->info->getComponentInterface()->print_xml(ss);
  ss << "\n";

  access_weak_ptr(result)->print_xml(ss);
  ss << "\n";

  xml_tag_close(ss, "vereofy_trace");
  ss << "\n";
  return ss.str();
}
