/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef MODELCHECKING_RESULT_FOR_JAVA_HPP
#define MODELCHECKING_RESULT_FOR_JAVA_HPP

#include <boost/shared_ptr.hpp>
#include "ModelCheckingResultTrace_for_java.hpp"

#ifdef SWIG
// fwd
class VereofyContext;
namespace vereofy {
  class ModelCheckingResult;
}
#endif

class ModelCheckingResult_for_java {
public:
  unsigned int countTraces() const;
  ModelCheckingResultTrace_for_java getTrace(unsigned int index);
  std::string getResultAsXML() const;

  boost::weak_ptr<VereofyContext> context;
  boost::weak_ptr<vereofy::ModelCheckingResult> result;
};

#endif
