/***************************************************************************
 *   Copyright (C) 2008-2009 by Sascha Klueppelholz                        *
 *   klueppel@tcs.inf.tu-dresden.de                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ASL_MODELCHECKER_HPP 
#define ASL_MODELCHECKER_HPP 

#include "vereofy/modelcheck/checkers/ModelChecker.hpp"

/**
 @author Sascha Klueppelholz
 */

namespace vereofy{

class ASL_ModelChecker : public ModelChecker {
public:
  ASL_ModelChecker();
  virtual ModelCheckingResult::ptr analyze(Automaton::ptr, Specification::ptr spec, const OptionContainer& options);

  virtual ModelChecker::ptr clone() {return ModelChecker::ptr(new ASL_ModelChecker);}

  virtual OptionContainer getOptions() const;
};

}
#endif
