/***************************************************************************
 *   Copyright (C) 2008-2009 by Sascha Klueppelholz                        *
 *   klueppel@tcs.inf.tu-dresden.de                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MCREO_SETUP_HPP
#define MCREO_SETUP_HPP

#include <string>
#include "vereofy/setup.hpp"

/**
 @author Sascha Klueppelholz
*/

namespace vereofy{

// ASL/BTSL formula types
enum BTSLFT{INVALID,ONE,ZERO,ATOM,NEG,CONJ,DISJ,EXOR,EES,EAS,EX,EF,EG,EU,ER,AAS,AES,AX,AF,AG,AU,AR};

// ASL/BTSL binary operators
  const std::string BTSLBO="&|^";

// binary operators on regular expressions of the ASL/BTSL
  const std::string REOPS=";|";

// types for witness class
enum w_info {WITNESS,COUNTEREXAMPLE,DEPENDS};
enum f_info {NONE,LEAST,GREATEST,UNDETERMINED};
	
struct witnessInfo{	
  w_info myType;
  f_info myFixpointType;
};

}

#endif
