/***************************************************************************
 *   Copyright (C) 2009 by Joachim Klein                                   *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SYMB_LTL_NBA_HPP
#define SYMB_LTL_NBA_HPP

#include "vereofy/modelcheck/specifications/LTL_Specification.hpp"
#include "BDD_NBA.hpp"

namespace vereofy {namespace ltl_check {

class Symb_LTL_NBA : public BDD_NBA {
public:
  typedef boost::shared_ptr<Symb_LTL_NBA> ptr;

  Symb_LTL_NBA(LTLFormula_ptr ltl,
               APSet_cp apset_,
               const ap_to_bddfunction_t& ap_to_bddfunction_=ap_to_bddfunction_t());


private:
  BDDFunction sat(LTLNode_p ltl_node);

  void degeneralize();

  std::vector<BDDFunction> gnba_accepting_states;
  std::vector<BDDFunction> ap_vars;
};

} // namespace ltl_check
} // namespace vereofy

#endif
