/***************************************************************************
 *   Copyright (C) 2008-2009 by Sascha Klueppelholz                        *
 *   klueppel@tcs.inf.tu-dresden.de                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#define USE_NEW_ASL_PARSER

#include "ASL_Parser.hpp"

#include "asl/ASLInfixParser.hpp"
#include "ASL_Specification.hpp"

using namespace std;
using namespace vereofy;

Specification::ptr ASL_Parser::parse(const string& spec,
                                     SystemContext::ptr system_context, 
                                     ComponentInterface::ptr system_interface) const {
#if defined(USE_NEW_ASL_PARSER)
  formula::ptr fptr = ASLInfixParser::parse(spec, system_context, system_interface);
#else
  formula::ptr fptr=formula::findOrAdd(spec);
  cout << "the new property syntax is: " << fptr->newSpec << endl;
#ifdef TEST_NEW_ASL_PARSER
  fptr = ASLInfixParser::parse(fptr->newSpec, system_context, system_interface);
#endif
#endif
  
	return ASL_Specification::ptr(new ASL_Specification(fptr));
}
