/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef ASL_SPECIFICATION_HPP
#define ASL_SPECIFICATION_HPP

#include <string>
#include "Specification.hpp"
#include "asl/ASL_Formula.hpp"

namespace vereofy{

class ASL_Specification : public Specification {
public:
  typedef boost::shared_ptr<ASL_Specification> ptr;

  ASL_Specification(formula::ptr formula_spec_) : Specification(ASL_SPEC), formula_spec(formula_spec_) {}

  virtual const std::string& getSpecification() const {return formula_spec->getSpecification();}

  formula::ptr getFormula();
  
private:
  formula::ptr formula_spec;
};
typedef ASL_Specification::ptr ASL_Specification_ptr;
}

#endif
