/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef LTL_SPECIFICATION_HPP
#define LTL_SPECIFICATION_HPP

#include <string>

#include "Specification.hpp"
#include "ltl/LTLFormula.hpp"

namespace vereofy {

class LTL_Specification : public Specification {
public:
  typedef boost::shared_ptr<LTL_Specification> ptr;

  LTL_Specification() : Specification(LTL_SPEC) {}
  LTL_Specification(ltl_check::LTLFormula_ptr ltl) : Specification(LTL_SPEC), ltl_formula(ltl) {}
  virtual const std::string& getSpecification() const {return spec;}

  ltl_check::LTLFormula_ptr getLTLFormula() {return ltl_formula;}

private:
  std::string spec;
  ltl_check::LTLFormula_ptr ltl_formula;
};

typedef LTL_Specification::ptr LTL_Specification_ptr;

}

#endif
