/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "SpecParserInit.hpp"
#include "vereofy/modelcheck/specifications/Specification.hpp"

using namespace std;
using namespace vereofy;

#ifdef HAVE_CHECKERS

// ASL
#include "vereofy/modelcheck/specifications/ASL_Parser.hpp"
#define HAVE_ASL_SPEC

// LTL
#include "vereofy/modelcheck/specifications/LTL_Parser.hpp"
#define HAVE_LTL_SPEC

void vereofy::init_spec_parsers() {
  #ifdef HAVE_ASL_SPEC
  SpecParser::registerParser("ASL", SpecParser::ptr(new ASL_Parser));
  #endif

  #ifdef HAVE_LTL_SPEC
  SpecParser::registerParser("LTL", SpecParser::ptr(new LTL_Parser));
  #endif
}

#endif
