/***************************************************************************
 *   Copyright (C) 2008-2009 by Sascha Klueppelholz                        *
 *   klueppel@tcs.inf.tu-dresden.de                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ASLINFIXPARSER_HPP
#define ASLINFIXPARSER_HPP

/** @file
 * Provides a parser for ASL formulas.
 */

#include "ASL_Formula.hpp"
#include "vereofy/system/system_context.hpp"
#include "vereofy/system/component_interface.hpp"
#include <string>

namespace vereofy{

/** 
 * A parser for ASL formulas
 */
class ASLInfixParser {
  public:
  static formula::ptr parse(std::string const& formula,
                            SystemContext::ptr system_context, 
                            ComponentInterface::ptr system_interface);
  };
}

#endif
