/*
 * This file is part of the program vereofy.
 * Copyright (C) 2008-2009 Joachim Klein <klein.inf.tu-dresden.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as 
 *  published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef LTLINFIXPARSER_HPP
#define LTLINFIXPARSER_HPP

/** @file
 * Provides a parser for LTL formulas.
 */

#include "LTLFormula.hpp"
#include "vereofy/common/checks.hpp"

#include <string>


#include <boost/tokenizer.hpp>

namespace vereofy {namespace ltl_check {

/** 
 * A parser for LTL formulas
 */
class LTLInfixParser {
public:

  /**
   * Parse the formula and return an LTLFormula_ptr
   * @param formula the formula string
   * @param predefined_apset if specified, use this APSet and don't 
   *                         add new atomic propositions
   * @return the LTLFormula_ptr
   */
  static LTLFormula_ptr parse(std::string const& formula,
			      APSet_cp predefined_apset=APSet_cp((APSet*)0));
};

}}

#endif
