/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/



#include "REOParseException.hpp"

using namespace vereofy;

REOParseException::REOParseException(const std::string& message_) {
  message=message_;
}

void REOParseException::setFile(const std::string& file_) {
  file=file_;
}

void REOParseException::setLocation(const std::string& location_) {
  location=location_;
}

void REOParseException::setContext(const std::string& context_) {
  context=context_;
}

const char* REOParseException::what() {
  calc_text();
  return text.c_str();
}

void REOParseException::calc_text() {
  text= (context!="" ? context : "Parser error");
  if (file!="" && location!="") {
    text+=" in "+file+" at "+location;
  } else if (file!="") {
    text+=" in "+file;
  } else if (location!="") {
    text+=" at "+location;
  }
  text+=":\n";
  text+=message;
}
