/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef REO_PARSER_EXCEPTION_HPP
#define REO_PARSER_EXCEPTION_HPP

#include <exception>
#include <string>

namespace vereofy {
  class REOParseException : public std::exception {
  public:
    REOParseException(const std::string& message);
    ~REOParseException() throw () {};

    virtual void raise() {throw *this;}

    void setFile(const std::string& file);
    void setLocation(const std::string& location);
    void setContext(const std::string& context);

    virtual const char* what();

    const std::string& getFile() const {return file;}
    const std::string& getLocation() const {return location;}
    const std::string& getMessage() const {return message;}
    const std::string& getContext() const {return context;}
    

  private:
    std::string message;
    std::string context;
    std::string file;
    std::string location;
    
    std::string text;

    void calc_text();
  };
}


#endif
