/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef CONST_DEF_PARSER_HELPER_HPP
#define CONST_DEF_PARSER_HELPER_HPP

#include "vereofy/common/checks.hpp"
#include "identifier_parser_helper.hpp"

namespace vereofy {
namespace vparser {

struct const_def_helper {

  struct t_const_def {
    static string getName(const pt_node& n) {
      ID_ASSERT_(n, ID_CO_const_def);
      return identifier_helper::t_identifier::getIdentifier(n.children.at(0));
    }

    static const pt_node& getValue(const pt_node& n) {
      ID_ASSERT_(n, ID_CO_const_def);
      return n.children.at(1);
    }
  };

  struct t_const_value_int {
    static int getIntValue(const pt_node& n,
                           const symbol_table_stack_t& symbols) {
      ID_ASSERT_(n, ID_CO_const_value_int);
      
      int_value_t i=int_helper::t_const_expression::evaluate(n.children.at(0), symbols);
      return i.getValue();
    }
  };

};



}
}

#endif
