/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef SPIRIT_INIT_HPP
#define SPIRIT_INIT_HPP

// define some BOOST_SPIRIT constants

// should be multiple of 3!
#define BOOST_SPIRIT_GRAMMAR_STARTRULE_TYPE_LIMIT 9

#if !defined(PHOENIX_LIMIT) || (PHOENIX_LIMIT < BOOST_SPIRIT_GRAMMAR_STARTRULE_TYPE_LIMIT)
#define PHOENIX_LIMIT BOOST_SPIRIT_GRAMMAR_STARTRULE_TYPE_LIMIT
#endif


#if !defined(BOOST_SPIRIT_NO_TREE_NODE_COLLAPSING)
#define BOOST_SPIRIT_NO_TREE_NODE_COLLAPSING 
#endif

// #define BOOST_SPIRIT_DEBUG
#define BOOST_SPIRIT_DUMP_PARSETREE_AS_XML


// get the specified entry grammar for a grammar with multiple start rules
// Parameters:
//  parser_name = the name of the auto variable that is generated
//  grammar_type = the class of the grammar
//  grammar_var = an instance of grammar_type
//  selector = the enum/int to specify which grammar entry point should be used
//
//  Warning: If the boost::spirit implementation changes, this will need to be adapted
#define ENTRY_GRAMMAR(parser_name, grammar_type, grammar_var, selector)	\
  vereofy::spirit::impl::entry_grammar<grammar_type, selector, vereofy::spirit::parser_context<> > parser_name \
  = grammar_var.use_parser<selector>();


#include <boost/spirit/home/classic/core.hpp>
#include <boost/spirit/home/classic/attribute.hpp>
#include <boost/spirit/home/classic/dynamic/if.hpp>
#include <boost/spirit/home/classic/utility/confix.hpp>
#include <boost/spirit/home/classic/utility/distinct.hpp>
#include <boost/spirit/home/classic/utility/lists.hpp>
#include <boost/spirit/home/classic/utility/grammar_def.hpp>
#include <boost/spirit/home/classic/symbols/symbols.hpp>
#include <boost/spirit/home/classic/tree/common.hpp>
#include <boost/spirit/home/classic/tree/ast.hpp>
#include <boost/spirit/home/classic/tree/parse_tree.hpp>
#include <boost/spirit/home/classic/tree/tree_to_xml.hpp>
#include <boost/spirit/home/classic/error_handling/exceptions.hpp>
#include <boost/spirit/home/classic/iterator.hpp>
#include <boost/spirit/home/classic/iterator/position_iterator.hpp>
#include <boost/spirit/home/classic/iterator/file_iterator.hpp>

namespace vereofy {
  namespace spirit = boost::spirit::classic;
}

#endif
