/***************************************************************************
 *   Copyright (C) 2009 by Joachim Klein                                   *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef BUILTIN_MAPPER_HPP
#define BUILTIN_MAPPER_HPP

#include <iostream>
#include <string>

#include <boost/shared_ptr.hpp>

#include "vereofy/system/reo_component.hpp"

namespace vereofy {

  class BuiltinMapper {
  public:
    BuiltinMapper();

    struct mapped {
      typedef boost::shared_ptr<mapped> ptr;
      
      mapped(const std::string& xml_tag_, 
             const std::string& reo_type_) :
        xml_tag(xml_tag_), reo_type(reo_type_) {}

      std::string xml_tag;
      std::string reo_type;
    };


    // Try to map to Reo ECT types and output opening XML tag.
    // If unsuccessful, return null pointer
    mapped::ptr mapToReoXML(std::ostream& out, REO_Component::ptr component) const;


  private:
    void init();

    std::map<string, string> simple_channels;
  };
}

#endif

