/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef CIRCUIT_CONNECTOR_HPP
#define CIRCUIT_CONNECTOR_HPP

#include <string>
#include <boost/shared_ptr.hpp>

#include "vereofy/system/component_interface.hpp"
#include "vereofy/system/system_context.hpp"
#include "vereofy/system/circuit_connector/circuit_connector_behavior.hpp"
#include "vereofy/reo_parser/reo_parser_types.hpp"


namespace vereofy {
  class CircuitConnector {
  public:
    typedef boost::shared_ptr<CircuitConnector> ptr;

    CircuitConnector(SystemContext::wptr context_, std::string name_) : 
      context(context_),
      name(name_),
      behavior(new CircuitConnectorBehavior) {}

    SystemContext::wptr context;
    std::string name;
    CircuitConnectorBehavior::ptr behavior;
  };
} 

#endif
