/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef SYMB_CIRCUIT_CONNECTOR_HPP
#define SYMB_CIRCUIT_CONNECTOR_HPP

#include "vereofy/common/shared_ptr_map.hpp"
#include "vereofy/setup.hpp"
#include "vereofy/system/component_instance.hpp"
#include "vereofy/system/circuit_connector/component_instance_circuit.hpp"
#include "vereofy/system/symb_automaton/symb_component_instance.hpp"

namespace vereofy {

class SymbCircuit : public SymbComponentInstance {
public:
  typedef boost::shared_ptr<SymbCircuit> ptr;
  
  SymbCircuit(ComponentInstanceCircuit::ptr ci_circuit,
              Symb_DataDomain::ptr dataDomain);
  
  virtual void hideInternalPorts(BuildContext::ptr build_context);
  virtual void build_automaton(BuildContext::ptr build_context);

private:
  void hideAnonymous(BuildContext::ptr build_context);

  bool first;

  void build_node(REO_Circuit::ptr reo_circuit, 
                  REO_Node::ptr node, 
                  BuildContext::ptr build_context, 
                  BDDFunction augmentation=BDDFunction::ONE());
  void build_component(REO_Circuit::ptr reo_circuit, REO_Component::ptr reo_component, BuildContext::ptr build_context);
  void plug_component(REO_Circuit::ptr reo_circuit, REO_Component::ptr reo_component);
};

}
#endif
