/***************************************************************************
 *   Copyright (C) 2009 by Joachim Klein                                   *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef COMPONENT_TYPE_IDENTIFIER_HPP
#define COMPONENT_TYPE_IDENTIFIER_HPP

#include <string>
#include <vector>

#include "vereofy/reo_parser/reo_parser_types.hpp"

namespace vereofy {

  class ComponentTypeIdentifier {
  public:
    std::string type_name;
    std::vector<Value::ptr> parameters;

    ComponentTypeIdentifier(const std::string& type_name,
                            const std::vector<Value::ptr>& parameters);
    ComponentTypeIdentifier(const std::string& type_name,
                            const std::vector<std::string>& parameters);
    ComponentTypeIdentifier(const std::string& id);

    std::string toString() const;

  private:
    void parameter_strings_to_value_vector(const std::vector<std::string>& parameter_strings);                              
  };

}

#endif
