/***************************************************************************
 *   Copyright (C) 2009 by Joachim Klein                                   *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef PORT_EQUIVALENCE_RELATION_HPP
#define PORT_EQUIVALENCE_RELATION_HPP

#include "vereofy/common/disjoint_sets.hpp"
#include "port_description.hpp"
#include "port_id.hpp"

#include <iostream>

#include <boost/shared_ptr.hpp>

namespace vereofy {

  class PortEquivalenceRelation {
  public:
    typedef boost::shared_ptr<PortEquivalenceRelation> ptr;

    void add(const PortID& port_id);
    void make_equivalent(const PortID& port_id_1, const PortID& port_id_2);

    bool are_equivalent(const PortID& port_id_1, const PortID& port_id_2);
    PortID getRepresentative(const PortID& port_id);

    void print(std::ostream& out);
  private:
    DisjointSets<PortID> port_partition;
  };
}


#endif
