/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef COMPONENT_INSTANCE_RM_HPP
#define COMPONENT_INSTANCE_RM_HPP

#include "vereofy/system/component_instance.hpp"
#include "vereofy/system/reactive_module/reactive_module.hpp"
#include "vereofy/system/symb_automaton/symb_automaton.hpp"
#include "vereofy/system/symb_automaton/var_positions.hpp"
#include "vereofy/system/symb_automaton/var_positions.hpp"


namespace vereofy {

class ComponentInstanceReactiveModule : public ComponentInstance {
public:
  typedef boost::shared_ptr<ComponentInstanceReactiveModule> ptr;

  ComponentInstanceReactiveModule(ReactiveModule::ptr module,
                                  const std::vector<Value::ptr>& parameters=std::vector<Value::ptr>());  

  ReactiveModule::ptr getModule();

  virtual boost::shared_ptr<SymbComponentInstance> getSymbAutomaton(ComponentInstance::ptr self,
                                                                    Symb_DataDomain::ptr s_dd);


  virtual void calculatePortPartitions(PortPartitions& port_partitions);
  
private:
  ReactiveModule::ptr module;

  void update_interface(ComponentInterface::ptr ci);
};


}

 
#endif
