/***************************************************************************
 *   Copyright (C) 2008-2009 by Tobias Blechmann                           *
 *   blechman@tcs.inf.tu-dresden.de                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/**
 @author Tobias Blechmann
 */

#include "vereofy/common/tracing.hpp"
#include "reo_graph_object.hpp"
#include <iostream>

using namespace std;

namespace vereofy {

  vertex_t REO_Graph_Object::getBOOST_Vertex() {
    return BOOST_Vertex;
  }

  void REO_Graph_Object::setBOOST_Vertex(vertex_t new_vertex) {
    TRACE("REO_Graph_Object", "setBOOST_Vertex", cout << this << " = " << new_vertex << endl);
    BOOST_Vertex = new_vertex;
  }

  std::string REO_Graph_Object::get_Description() {
    return boost::lexical_cast<string>( int(graph_object_type) );
  }

  REO_Graph_Object::Graph_Object_Type REO_Graph_Object::get_graph_object_type() { 
    return graph_object_type; 
  }

}

