/***************************************************************************
 *   Copyright (C) 2009 by Joachim Klein                                   *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "vereofy/common/setup.hpp"
#include "replacement_manager.hpp"
#include <iostream>

using namespace vereofy;
using namespace std;

void ReplacementManager::addReplacement(const std::string& type_name, const std::string& typename_replacement) {
  bool inserted=replacements.insert(make_pair(type_name, typename_replacement)).second;
  if (!inserted) {
    std::cout << " * Warning: Replacement for " << type_name << 
      " was not inserted, as there is already one to " << getReplacement(type_name) << ".\n";
  }

  if (debugLevel>=2) {
    std::cout << "Adding replacement from '" << type_name << "' to '" << typename_replacement << "'\n";
  }
}

bool ReplacementManager::hasReplacement(const std::string& type_name) {
  return replacements.count(type_name)>0;
}
std::string ReplacementManager::getReplacement(const std::string& type_name) {
  if (hasReplacement(type_name)) {
    return replacements.find(type_name)->second;
  } else {
    return type_name;
  }
}


