/***************************************************************************
 *   Copyright (C) 2009 by Joachim Klein                                   *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/



#ifndef REPLACEMENT_MANAGER_HPP
#define REPLACEMENT_MANAGER_HPP

#include <string>
#include <map>
#include <boost/shared_ptr.hpp>

namespace vereofy {
  class ReplacementManager {
  public:
    typedef boost::shared_ptr<ReplacementManager> ptr;

    void addReplacement(const std::string& type_name, const std::string& typename_replacement);

    bool hasReplacement(const std::string& type_name);
    std::string getReplacement(const std::string& type_name);
  private: 
    std::map<std::string, std::string> replacements;
  };

};

#endif
