/***************************************************************************
 *   Copyright (C) 2009 by Joachim Klein                                   *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "state_id.hpp"
#include "component_instance.hpp"
#include "state_description.hpp"

using namespace vereofy;

void StateID::print(std::ostream& out) const {
  std::string component_name=getComponentInstance().getFQName();
  if (component_name=="") {
    out << getStateDescription().getName();
  } else {
    out << component_name << "." << getStateDescription().getName();
  }
}


bool StateID::operator<(const StateID& other) const {
  if (component_instance->getID() == other.component_instance->getID()) {
    return state_description->getID() < other.state_description->getID();
  }
  
  return (component_instance->getID() < other.component_instance->getID());
}

bool StateID::operator==(const StateID& other) const {
  return ((component_instance == other.component_instance) &&
          (state_description == other.state_description));
}
