/***************************************************************************
 *   Copyright (C) 2009 by Joachim Klein                                   *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef SYMB_FUNCTION_CONSTRUCTOR_HPP
#define SYMB_FUNCTION_CONSTRUCTOR_HPP

#include "symb_datadomain.hpp"
#include "symb_function.hpp"

namespace vereofy {
  class SymbFunction_Constructor : public SymbFunction {
  public:
    typedef boost::shared_ptr<SymbFunction_Constructor> ptr;

    SymbFunction_Constructor(Symb_DataDomain::ptr symb_dd_) :
      SymbFunction(symb_dd_->getDataDomain()->getConstructorArgumentsCount(),
                   RETURN_VALUE_COMPLEX,
                   false),
      symb_dd(symb_dd_) {}

    
    Symb_DataDomain::ptr getConstructorReturnValueType() const {
      return symb_dd;
    }
    
  protected:
    Symb_DataDomain::ptr symb_dd;
  };

}

#endif
