/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef SYMB_FUNCTION_SEQ_NUMBER_ARITHMETIC_HPP
#define SYMB_FUNCTION_SEQ_NUMBER_ARITHMETIC_HPP

#include "symb_function_arithmetic.hpp"

namespace vereofy {

  class SymbFunction_seq_number_add : public SymbFunction_Arithmetic {
  public:
    SymbFunction_seq_number_add() : SymbFunction_Arithmetic(3) {}

    bool requiresConstArgumentAt(unsigned int index) const {return index==0;}

    SymbExpression::ptr calculate(SymbFunctionArgumentVector& arguments) const;
    unsigned int const_evaluate(SymbFunctionArgumentVector& arguments) const;
  };
  
  class SymbFunction_seq_number_less : public SymbFunction_Arithmetic {
  public:
    SymbFunction_seq_number_less() : SymbFunction_Arithmetic(3, SymbFunction::RETURN_VALUE_BOOLEAN) {}

    bool requiresConstArgumentAt(unsigned int index) const {return index==0;}

    SymbExpression::ptr calculate(SymbFunctionArgumentVector& arguments) const;
    unsigned int const_evaluate(SymbFunctionArgumentVector& arguments) const;
  };

  class SymbFunction_seq_number_less_equal : public SymbFunction_Arithmetic {
  public:
    SymbFunction_seq_number_less_equal() : SymbFunction_Arithmetic(3, SymbFunction::RETURN_VALUE_BOOLEAN) {}

    bool requiresConstArgumentAt(unsigned int index) const {return index==0;}

    SymbExpression::ptr calculate(SymbFunctionArgumentVector& arguments) const;
    unsigned int const_evaluate(SymbFunctionArgumentVector& arguments) const;
  };

  class SymbFunction_seq_number_greater : public SymbFunction_Arithmetic {
  public:
    SymbFunction_seq_number_greater() : SymbFunction_Arithmetic(3, SymbFunction::RETURN_VALUE_BOOLEAN) {}

    bool requiresConstArgumentAt(unsigned int index) const {return index==0;}

    SymbExpression::ptr calculate(SymbFunctionArgumentVector& arguments) const;
    unsigned int const_evaluate(SymbFunctionArgumentVector& arguments) const;
  };

  class SymbFunction_seq_number_greater_equal : public SymbFunction_Arithmetic {
  public:
    SymbFunction_seq_number_greater_equal() : SymbFunction_Arithmetic(3, SymbFunction::RETURN_VALUE_BOOLEAN) {}

    bool requiresConstArgumentAt(unsigned int index) const {return index==0;}

    SymbExpression::ptr calculate(SymbFunctionArgumentVector& arguments) const;
    unsigned int const_evaluate(SymbFunctionArgumentVector& arguments) const;
  };


  class SymbFunction_seq_number_max : public SymbFunction_Arithmetic {
  public:
    SymbFunction_seq_number_max() : SymbFunction_Arithmetic(3) {}

    bool requiresConstArgumentAt(unsigned int index) const {return index==0;}

    SymbExpression::ptr calculate(SymbFunctionArgumentVector& arguments) const;
    unsigned int const_evaluate(SymbFunctionArgumentVector& arguments) const;
  };

}

#endif
