/***************************************************************************
 *   Copyright (C) 2008-2010 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef SYMB_FUNCTION_USERDEFINED_HPP
#define SYMB_FUNCTION_USERDEFINED_HPP

#include <boost/shared_ptr.hpp>
#include "symb_expression.hpp"
#include "symb_function.hpp"
#include "vereofy/system/system_context.hpp"

#include "vereofy/reo_parser/reo_parser_types.hpp"

namespace vereofy {

  class SymbFunction_Userdefined : public SymbFunction {      
  public:                        
    typedef boost::shared_ptr<SymbFunction> ptr;
    
    SymbFunction_Userdefined(unsigned int arity_, 
                             SymbFunction::return_value_t rv_,
                             const vparser::pt_node& function_def_,
                             SystemContext::wptr context_);
    virtual ~SymbFunction_Userdefined();

    virtual SymbExpression::ptr calculate(SymbFunctionArgumentVector& arguments) const;
    
    static SymbFunction_Userdefined::ptr fromDef(const vparser::pt_node& function_def_, SystemContext::wptr context_);

  private:
    vparser::pt_node function_def;
    SystemContext::wptr context;
  };

}

#endif
