/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef SYMB_MAPS_HPP
#define SYMB_MAPS_HPP

#include <boost/shared_ptr.hpp>
#include "vereofy/common/shared_ptr_map.hpp"
#include "vereofy/system/port_description.hpp"
#include "vereofy/system/state_description.hpp"
#include "vereofy/system/transition_label_description.hpp"
#include "symb_channel_end.hpp"
#include "symb_transition_label_var.hpp"
#include "symb_automaton.hpp"

namespace vereofy {
  typedef 
  shared_ptr_id_map<PortDescription::ptr, 
                    Symb_Channel_End::ptr>::type port_to_bdd_map;
  
  typedef 
  shared_ptr_id_multimap<Symb_Channel_End::ptr,
                         PortDescription::ptr>::type ce_to_port_map;
  
  struct SymbolicState {
    typedef boost::shared_ptr<SymbolicState> ptr;
    
    StateVars vars;
    Symb_DataDomain::ptr data_domain;
  };
  
  typedef 
  shared_ptr_id_map<StateDescription::ptr, 
                    SymbolicState::ptr>::type state_to_bdd_map;

  typedef 
  shared_ptr_id_map<TransitionLabelDescription::ptr, 
                    Symb_Transition_Label_Var::ptr>::type transition_label_to_bdd_map;


  // fwd
  class SymbComponentInstance;
  class SymbComponentInfo;
  
  typedef
  map<string, boost::shared_ptr<SymbComponentInstance> > subcomponent_automaton_map;

  typedef
  map<string, boost::shared_ptr<SymbComponentInfo> > subcomponent_info_map;

}

#endif
