/***************************************************************************
 *   Copyright (C) 2009 by Joachim Klein                                   *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef SYMB_TRACE_LASSO_HPP
#define SYMB_TRACE_LASSO_HPP

#include "symb_trace.hpp"
#include <boost/shared_ptr.hpp>
#include <iostream>

namespace vereofy {

  // fwd
  class SymbComponentInstance;

  /**
   * A class representing an infinite trace,
   * having a finite prefix and then a cycle.
   */
  class SymbTraceLasso {
  public:
    typedef boost::shared_ptr<SymbTraceLasso> ptr;

    SymbTraceLasso() {}
    SymbTraceLasso(SymbTrace::ptr prefix_) : 
      prefix(prefix_) {}

    void print(SymbComponentInstance& system, std::ostream& out);
    void print_xml(SymbComponentInstance& system, std::ostream& out) const;

    SymbTrace::ptr merge() const;

    SymbTrace::ptr prefix;
    SymbTrace::ptr cycle;
  };

}
#endif
