/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/



#include "symb_variable_id.hpp"


namespace vereofy {
  
  SymbVariableID::SymbVariableID(vid_type_t type_, unsigned int bit_) :
    type(type_), bit(bit_) {}
  
  SymbVariableID::vid_type_t SymbVariableID::getType() const {
    return type;
  }

  unsigned int SymbVariableID::getBit() const {
    return bit;
  }

  bool SymbVariableID::operator==(const SymbVariableID& other) const {
    return this->equals(other);
  }

  bool SymbVariableID::equals(const SymbVariableID& other) const {
    return type==other.type && bit==other.bit;
  }
  
  bool SymbVariableID::operator<(const SymbVariableID& other) const {
    return this->less(other);
  }

  bool SymbVariableID::less(const SymbVariableID& other) const {
    if (type<other.type) return true;
    if (type>other.type) return false;

    // type==other.type
    return bit<other.bit;
  }

  SymbVariableID::ptr SymbVariableID::getNextBit() const {
    return nextBit;
  }

  void SymbVariableID::setNextBit(boost::shared_ptr<SymbVariableID> nextBit_) {
    nextBit=nextBit_;
  }

  boost::shared_ptr<SymbVariableID> SymbVariableID::getPrevBit() const {
    return prevBit;
  }

  void SymbVariableID::setPrevBit(boost::shared_ptr<SymbVariableID> prevBit_) {
    prevBit=prevBit_;
  }


}
