/***************************************************************************
 *   Copyright (C) 2008-2009 by Joachim Klein                              *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef SYMB_VARIABLE_ID_PORT_HPP
#define SYMB_VARIABLE_ID_PORT_HPP

#include "vereofy/system/component_instance.hpp"
#include "symb_variable_id.hpp"

namespace vereofy {
  
  class SymbVariableID_Port : public SymbVariableID {
  public:
    typedef boost::shared_ptr<SymbVariableID_Port> ptr;

    SymbVariableID_Port(ComponentInstance::ptr ci_,
                        PortDescription::ptr port_,
                        unsigned int bit_);

    virtual bool equals(const SymbVariableID& other) const;
    virtual bool less(const SymbVariableID& other) const;

    ComponentInstance::ptr getComponentInstance() const;
    PortDescription::ptr getPortDescription() const;

  private:
    ComponentInstance::ptr ci;
    PortDescription::ptr port;
  };

}


#endif 
