/***************************************************************************
 *   Copyright (C) 2009 by Joachim Klein                                   *
 *   vereofy@tcs.inf.tu-dresden.de                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef TYPE_MODIFICATION_REGISTRY_HPP
#define TYPE_MODIFICATION_REGISTRY_HPP

#include <vector>
#include <string>
#include <boost/shared_ptr.hpp>

#include "atomic_proposition_spec.hpp"

namespace vereofy {

  class TypeModificationRegistry {
  public:
    typedef boost::shared_ptr<TypeModificationRegistry> ptr;    

    void addAtomicProposition(const std::string& type_specifier, 
                              const std::string& ap_name,
                              const std::string& ap_formula);
    
    AtomicPropositionSpec::vector getAtomicPropositionsForType(const std::string& type_name) const;

  private:
    
    static bool matchesTypeSpecifier(const std::string& type_name, const std::string& type_specifier);

    struct APSpecAttachement {
      std::string type_specifier;
      AtomicPropositionSpec ap_spec;
    };

    std::vector<APSpecAttachement> ap_attachements;
  };

}

#endif
