#! /usr/bin/perl -w


my @files=@ARGV;

die if !@files;

open(IN, "< $files[0]") or die;

my @headers;
my $line=<IN>;
if (defined $line) {
  chomp($line);
  @headers=split(/;/, $line);
} else {
  print STDERR "No headers!";
  exit 1;
}

close(IN);

shift @headers;

print 'set terminal pdf', "\n";
print 'set datafile separator ";"', "\n";

for (my $i=0;$i<@headers;$i++) {
  print 'set output "', $headers[$i], '.pdf"', "\n";
  print 'set title "', $headers[$i], '"', "\n";
  print 'set xtics', "\n";

  print 'plot ';
  for (my $j=0;$j<@files;$j++) {
    print ', ' if $j>0;
    print '"', $files[$j], '" using ', ($i+2), ':xticlabels(1) title "', $files[$j], '"';
  }
  print "\n";
}

