#! /usr/bin/perl -w

# Generate GNUPlot script to plot the level sizes
# Usage: perl plot_level_sizes.pl size_file(s)... | gnuplot
# Results in level_sizes.pdf
#
# Currently only handles .sizes files with 2 arguments and 1 result
#


use strict;

my $terminal="pdf";
my $file_ending="pdf";

while (@ARGV) {
    my $arg=$ARGV[0];
    if ($arg eq '--pdf') {
	$file_ending="pdf";
	$terminal="pdf";
    } elsif ($arg eq '--ps') {
	$terminal="postscript";
	$file_ending="ps";
    } else {
	last;
    }    

    shift @ARGV;
}

my $arg_1_color="light-blue";
my $arg_2_color="dark-blue";

print "set terminal $terminal\n";
print 'set datafile separator ";"', "\n";
print 'set style histogram cluster gap 1', "\n";
print 'set style fill solid noborder', "\n";
print 'set style data histogram', "\n";
#print 'set logscale y', "\n";
print 'set xrange [0:*]', "\n";
print "set output \"level_sizes.$file_ending\"\n";

foreach (@ARGV) {
    my $file=$_;
#
    print "set title \"$file\"\n";
    print "plot \"$file\" using 3 with histeps linecolor rgb \"red\" title \"Result\", \"$file\" using 4 with histogram linecolor rgb \"$arg_1_color\" title \"Arg1\", \"$file\" using 5 with histogram linecolor rgb \"$arg_2_color\" title \"Arg2\", \"$file\" using :(0):2 with points lc variable pt 2 notitle;\n";
}
